#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <getopt.h>
#include <time.h>
#include <gd.h>
#include <gdfontl.h>
#include <gdfonts.h>
#include <gdfontt.h>
#include <sys/types.h>
#include <unistd.h>


#define FIXED_HOLIDAY "holidays.fixed"
#define FIXED_APPOINTED "appointed.fixed"

#define BUTTON_OK "Generieren"
#define BUTTON_RESET "Nochmal"
#define TEXT_SIZE "Gr&ouml;&szlig;e"
#define TEXT_QUALITY "Qualit&auml;t"
#define TEXT_IMAGETYPE "Ausgabeformat"
#define TEXT_COLORS "Farben"
#define TEXT_BGCOLOR "Hintergrund"
#define TEXT_TCOLOR "Text"
#define TEXT_HCOLOR "Feiertage"
#define TEXT_ACOLOR "Termine"
#define TEXT_DCOLOR "Heute"
#define TEXT_SBGCOLOR "Kalender-Hintergrund"
#define TEXT_CAL "Kalender"
#define TEXT_POSITION "Position"
#define TEXT_FREEPOSITION "Spezielle Postition"
#define TEXT_YEARCAL "Jahreskalender"
#define TEXT_DISABLE "Nicht benutzen"
#define TEXT_HORZ	"Horizontal"
#define TEXT_VERT "Vertical"
#define TEXT_TWOCAL "Zwei Monate"
#define TEXT_DOWNLOAD "Download"
#define TEXT_BACKGROUNDIMAGE "Hintergrundbild"
#define TEXT_IMAGESCAL_DEFAULT "default"
#define TEXT_IMAGESCAL_FIT "passend"
#define TEXT_IMAGESCAL_TILED "gekachelt"
#define TEXT_IMAGESCAL_CENTER "mittig"
#define TEXT_IMAGESCAL_STRETCH "gestreckt"
#define TEXT_DATE "Erstellen f&uuml;r"
#define TEXT_DAY "Tag"
#define TEXT_MONTH "Monat"
#define TEXT_YEAR "Jahr"
#define TEXT_MARKTODAY "&quot;Tag&quot; markieren"

#define HASSUMMERTIME
#define HASMOTHERSDAY
#define CONVERT "convert png:- bmp:"

#define HELP_CALBG "This could be your help !"

#define DEF_WIDTH 1024
#define DEF_HEIGHT 768

#define DEF_BGCOLOR "darkgreen"
#define DEF_TCOLOR "yellow"
#define DEF_HCOLOR "red"
#define DEF_ACOLOR "blue"
#define DEF_DCOLOR "gray"
#define DEF_SBGCOLOR "black"

#define DEF_POSITION 3
#define DEF_YPOSITION 7
#define DEF_TWO 0
#define DEF_YLAYOUT 'h'

#define VERS 3

#define JPEG_QUALITY -1
#define JPG_DEFAULT 0

#define MAXSTRING 256
#define MAXCOLOR 20

#define PROGNAME "CalBG"
#define PROGNAME_LONG "Calendar-Creator"

#define ANZARGS 30

char TMPFILE[MAXSTRING+1];
#define TMPPREFIX "/tmp/calbg."

/* Month */
char *MO(int month) {
	switch(month) {
		case 1:
			return("Januar");
		break;
		case 2:
			return("Februar");
		break;
		case 3:
			return("Mrz");
		break;
		case 4:
			return("April");
		break;
		case 5:
			return("Mai");
		break;
		case 6:
			return("Juni");
		break;
		case 7:
			return("Juli");
		break;
		case 8:
			return("August");
		break;
		case 9:
			return("September");
		break;
		case 10:
			return("Oktober");
		break;
		case 11:
			return("November");
		break;
		case 12:
			return("Dezember");
		break;
		default:
			return("Unknown");
		break;
	}
	return(NULL);
}
/* WeekDays */
char *WD(int day, int l) {
	switch(day) {
		case 1:
			if(l==0)
				return("Mo");
			else
				return("Montag");
		break;
		case 2:
			if(l==0)
				return("Di");
			else
				return("Dienstag");
		break;
		case 3:
			if(l==0)
				return("Mi");
			else
				return("Mittwoch");
		break;
		case 4:
			if(l==0)
				return("Do");
			else
				return("Donnerstag");
		break;
		case 5:
			if(l==0)
				return("Fr");
			else
				return("Freitag");
		break;
		case 6:
			if(l==0)
				return("Sa");
			else
				return("Samstag");
		break;
		case 7:
			if(l==0)
				return("So");
			else
				return("Sonntag");
		break;
		default:
			if(l==0)
				return("ERR");
			else
				return("ERROR");
		break;
	}
	return(NULL);
}

/* Signum */
int sgn(int value) {
	if(value < 0)
		return(-1);
	if(value > 0)
		return(1);
	return(0);
}

/* Float Maximum */
float fmax(float x1,float x2) {
	if(x1 >= x2)
		return(x1);
	else
		return(x2);
}



/* Maximum */
int max(int x1,int x2) {
	if(x1 >= x2)
		return(x1);
	else
		return(x2);
}

/* Float Minimum */
float fmin(float x1, float x2) {
	if(x1 <= x2)
		return(x1);
	else
		return(x2);
}

/* Minimum */
int min(int x1, int x2) {
	if(x1 <= x2)
		return(x1);
	else
		return(x2);
}

/* Year */
int JJ(int jg) {
	return(jg%100);
}

/* Century */
int JH(int jg) {
	return(jg/100);
}

/* First Day of Century (JG) correction-value */
int AJH(int jg) {
	return(7 - 2 * (JH(jg) % 4));
}

/* leap Year */
int SJS(int jg) {
	return(sgn(jg%100) - sgn(JJ(jg)%4) + 1 - sgn(jg % 400));
}

/* First day of a year */
int WWT(int jg) {
	return(((JJ(jg) + AJH(jg) + JJ(jg)/4 + 6 - SJS(jg)) % 7) + 1);
}

/* Number of days of a month */
int ME(int month, int jg) {
	return(30 + ((month + month/8) % 2) - (1-abs(sgn(month-2))) * (2-SJS(jg)));
}

/* Weekday correction value */
int MT(int month, int year) {
	return((month-2)*2 + (month + month/9)/2 + 2*(month < 3) + SJS(year)*(month > 2));
}

/* Weekday */
int WT(int day, int month, int year) {
	return(((WWT(year) + MT(month,year) + day + 5) % 7) +1);
}

/* Number of day */
int ND(int day, int month, int year) {
	int i1;
	int num;
	num=0;
	for(i1=1; i1<month; i1++) {
		num+=ME(i1,year);
	}
	num+=day;
	return(num);
}

/* Calender Week */
int CW(int day, int month, int year) {
		
	int i1;
	for(i1=1; i1<month; i1++)
	return((((WWT(year) + 2)%7) + 3 + ND(day,month,year) ) / 7);
}

/* Date by Day-Number */
int DbN(int number, int year) {
	int month;
	int day;
	int count;

	month=0;
	day=0;
	count=0;

	while(count < number) {
		month++;
		count+=ME(month,year);
	}
	count -= ME(month,year);
	while(count+day < number) 
		day++;
		
	return(100*day+month);
}

/* Easter-Sunday */
int EasterSunday(int year) {
	int a,b,c,d,e,f,g,h,i,k,l,m,n,p;

	a=year%19;
	b=year/100;
	c=year%100;
	d=b/4;
	e=b%4;
	f=(b+8)/25;
	g=(b-f+1)/3;
	h=(19*a+b-d-g+15)%30;
	i=c/4;
	k=c%4;
	l=(32+2*e+2*i-h-k)%7;
	m=(a+11*h+22*l)/451;
	n=(h+l-7*m+114)/31;
	p=(h+l-7*m+114)%31+1;

	return(p*100+n);
}

/* Kar-Friday */
int Kar(int year) {
	int easter;

	easter=EasterSunday(year);
	return(DbN(ND(easter/100,easter%100,year)-2,year));
}

/* Easter-Monday */
int EasterMonday(int year) {
	int easter;

	easter=EasterSunday(year);
	return(DbN(ND(easter/100,easter%100,year)+1,year));
}

/* Assumption */
int Assum(int year) {
	int easter;

	easter=EasterSunday(year);
	return(DbN(ND(easter/100,easter%100,year)+39,year));
}

/* Pentecost Sunday */
int PenteSu(int year) {
	int pentemo;

	pentemo=PenteMo(year);

	return(DbN(ND(pentemo/100,pentemo%100,year)-1,year));
}
	
/* Pentecost Monday*/
int PenteMo(int year) {
	int TPF,TP,MP,T,MO,kar;

	kar=Kar(year);

	T=kar/100;
	MO=kar%100;

	TPF = T + 52 - 31 + MO - 3;
	TP = ((TPF - 1) % (30 + MO - 3)) + 1;
	MP = 5 + (MO -3) * ((T + 21) / 31);

	return(TP*100+MP);
}

/* Summertime Begin */
int SumBeg(year) {
	/* Summertime starts at last Sunday in March, 2am->3am */
	return((31-(WT(31,3,year)%7))*100+3);
}

/* Summertime End */
int SumEnd(year) {
/* Summertime ends at last Sunday in October, 3am->2am */
	return((31-(WT(31,10,year)%7))*100+10);
}


void test(int day, int month, int year) {
	printf("Kalender fuer den %i.%i.%i\n",day,month,year);
	printf("Anfangswochentag des Jahrhunderts (Zwi): %i=%s\n",AJH(year),WD(AJH(year),1));
	printf("Schaltjahr? %i:%i\n",year,SJS(year));
	printf("Anfangswochentag des Jahres: %i=%s\n",WWT(year),WD(WWT(year),1));
	printf("Anzahl der Tage dieses Monats: %i\n",ME(month,year));
	printf("MT:%i\n",MT(month,year));
	printf("Wochentag: %i=%s\n",WT(day,month,year),WD(WT(day,month,year),1));
	printf("Kalenderwoche: %i\n",CW(day,month,year));
	printf("Tag des Jares: %i\n",ND(day,month,year));
	printf("Datum aufgrund der Tagesanzahl: %i\n",DbN(ND(day,month,year),2002));
	printf("Karfreitag: %i\n",Kar(year));
	printf("Ostersonntag: %i\n",EasterSunday(year));
	printf("Ostermontag: %i\n",EasterMonday(year));
	printf("Himmelfahrt: %i\n",Assum(year));
	printf("Pfingstsonntag: %i\n",PenteSu(year));
	printf("Pfingstmontag: %i\n",PenteMo(year));
	printf("Beginn der Sommerzeit: %i\n",SumBeg(year));
	printf("Ende der Sommerzeit: %i\n",SumEnd(year));

}

/* GetColor */
int getColor(gdImagePtr image, char *name) {
	char tmpr[3],tmpg[3],tmpb[3];
	if(strcmp(name,"red") == 0) {
		return(gdImageColorAllocate(image,255,0,0));
	}
	if(strcmp(name,"blue") == 0) {
		return(gdImageColorAllocate(image,0,0,255));
	}
	if(strcmp(name,"green") == 0) {
		return(gdImageColorAllocate(image,0,255,0));
	}
	if(strcmp(name,"magenta") == 0) {
		return(gdImageColorAllocate(image,255,0,255));
	}
	if(strcmp(name,"yellow") == 0) {
		return(gdImageColorAllocate(image,255,255,0));
	}
	if(strcmp(name,"cyan") == 0) {
		return(gdImageColorAllocate(image,0,255,255));
	}
	if(strcmp(name,"black") == 0) {
		return(gdImageColorAllocate(image,0,0,0));
	}
	if(strcmp(name,"white") == 0) {
		return(gdImageColorAllocate(image,255,255,255));
	}

	if(strcmp(name,"darkred") == 0) {
		return(gdImageColorAllocate(image,127,0,0));
	}
	if(strcmp(name,"darkblue") == 0) {
		return(gdImageColorAllocate(image,0,0,127));
	}
	if(strcmp(name,"darkgreen") == 0) {
		return(gdImageColorAllocate(image,0,127,0));
	}
	if(strcmp(name,"darkmagenta") == 0) {
		return(gdImageColorAllocate(image,127,0,127));
	}
	if(strcmp(name,"darkyellow") == 0) {
		return(gdImageColorAllocate(image,127,127,0));
	}
	if(strcmp(name,"darkcyan") == 0) {
		return(gdImageColorAllocate(image,0,127,127));
	}
	if(strcmp(name,"gray") == 0) {
		return(gdImageColorAllocate(image,127,127,127));
	}
	if(strcmp(name,"darkgray") == 0) {
		return(gdImageColorAllocate(image,63,63,63));
	}
	
	if((strlen(name) == 7) && (*name == '#')) {
		name++;
	}
	if(strlen(name) == 6) {
		tmpr[0]=name[0];
		tmpr[1]=name[1];
		tmpr[2]=(char)NULL;
		tmpg[0]=name[2];
		tmpg[1]=name[3];
		tmpg[2]=(char)NULL;
		tmpb[0]=name[4];
		tmpb[1]=name[5];
		tmpb[2]=(char)NULL;

		return(gdImageColorAllocate(image,strtol(tmpr, (char **)NULL, 16),strtol(tmpg, (char **)NULL, 16),strtol(tmpb, (char **)NULL, 16)));
	}
	

	return(gdImageColorAllocate(image,0,0,0));

}

/* X-Position of a day in a calendar */
int xpos(int day, int month, int year) {

	return(((WT(1,month,year)+day-2)%7));
}

/* Y-Position of a day in a calendar */
int ypos(int day, int month, int year) {
	return((WT(1,month,year)+day-2)/7);
}

/* Get a line from a file */
int getLineFromFile(FILE *file,char *tmp,unsigned max) {
	char *z1;
	int i1;
	unsigned count;
	
	z1=tmp;
	count=0;
	
	i1=fgetc(file);
	while((i1 != EOF) && (i1 != 0xa) && (count < max)) {
		if((count != 0) || (i1 != ' ')) {
			*z1=(char)i1;
			z1++;
			count++;
		}
		i1=fgetc(file);
	}	
	*z1=(char)NULL;
	
	if(i1 == EOF)
		count=-1;
	
	return(count);
}

/* Search for Special-Days */
char *getSpecialDay(char *datei,int day,int month, int number) {
	FILE *file;
	char tmp[MAXSTRING+1];
	char *z1;
	int i1,iday,imonth;
	int oft;
	
	file=fopen(datei,"r");
	if(file == (FILE *)NULL)
		return(NULL);
	oft=0;
	tmp[0]=(char)NULL;
	i1=getLineFromFile(file,tmp,MAXSTRING);		
	while(i1 >= 0) {
		sscanf(tmp,"%i %i",&iday,&imonth);
		if((iday == day) && (imonth == month)) {
			if(oft == number) {
				fclose(file);
				z1=tmp;
				while((*z1 == ' ') && (*z1 != (char)NULL)) /* Spaces at the beginning */
					z1++;
				while((*z1 != ' ') && (*z1 != (char)NULL)) /* The day */
					z1++;
				while((*z1 == ' ') && (*z1 != (char)NULL)) /* Spaces between day and month */
					z1++;
				while((*z1 != ' ') && (*z1 != (char)NULL)) /* The month */
					z1++;
				while((*z1 == ' ') && (*z1 != (char)NULL)) /* Spaces before text */
					z1++;
				return(z1);
			}
			else {
				oft++;
			}
		}
		
		i1=getLineFromFile(file,tmp,MAXSTRING);
	}
	fclose(file);

	return(NULL);
}
/* Is the given day an holiday ? */
char *isHoliday(int day, int month, int year, int number) {
	int coded=day*100+month;

	if(WT(day,month,year) == 7) /* Sunday */
		return("");
	if(coded == EasterSunday(year)) /* Easter Sunday */
		return("OsterSonntag");
	if(coded == Kar(year))			/* Kar-Friday */
		return("Kar-Freitag");
	if(coded == EasterMonday(year))	/* Easter Monday */
		return("OsterMontag");
	if(coded == Assum(year))		/* Assumption */
		return("Himmelfahrt");
	if(coded == PenteMo(year))		/* Pentecost Monday */
		return("PfingstMontag");
	if(coded == PenteSu(year))		/* Pentecost Sunday */
		return("PfingstSonntag");
	return(getSpecialDay(FIXED_HOLIDAY,day,month, number));
}

/* Is the given day an appointed day ? */
char *isAppointed(int day, int month, int year, int number) {
	int coded=day*100+month;

#ifdef HASSUMMERTIME
	if(coded == SumBeg(year))	/* Begin Summertime */
		return("Beginn der Sommerzeit");
	if(coded == SumEnd(year))	/* End Summertime */
		return("Ende der Sommerzeit");
#endif
#ifdef HASMOTHERSDAY
	if((month == 5) && (day >= 8) && (day <= 15) && (WT(day,month,year) == 7))	/* Mothers day */
		return("Muttertag");
#endif
	return(getSpecialDay(FIXED_APPOINTED,day,month, number));
}


/* Create small Calendar at x,y */
void SmallGraphCal(gdImagePtr image, gdFontPtr font, int day, int month, int year, int x, int y, int tcolor, int hcolor, int acolor, int sbgcolor, int dcolor) {
	char TMPSTRING[MAXSTRING+1];
	int i1;
	int me;

	me=ME(month,year);

	gdImageFilledRectangle(image, x, y, x+(20*font->w), y+((3+ypos(me,month,year))*(font->h)), sbgcolor);
	
	gdImageString(image, font, x, y, MO(month), tcolor);
	snprintf(TMPSTRING,(size_t)MAXSTRING,"%s %s %s %s %s %s %s",WD(1,0),WD(2,0),WD(3,0),WD(4,0),WD(5,0),WD(6,0),WD(7,0));
	gdImageString(image, font, x, y+font->h, TMPSTRING, tcolor);

	for(i1=1; i1<=me; i1++) {
		if(i1==day) {
			gdImageFilledRectangle(image, x+(xpos(i1,month,year)*3*(font->w))-1,y+(2+ypos(i1,month,year))*(font->h),x+(xpos(i1,month,year)*3*(font->w))+2*(font->w)+1,y+(3+ypos(i1,month,year))*(font->h), dcolor);
		}
		snprintf(TMPSTRING,(size_t)MAXSTRING,"%2i",i1);
		if(isAppointed(i1,month,year,0) != NULL)
			gdImageString(image, font, x+(xpos(i1,month,year)*3*(font->w)), y+(2+ypos(i1,month,year))*(font->h), TMPSTRING, acolor);
		else {
		if(isHoliday(i1,month,year,0) != NULL)
			gdImageString(image, font, x+(xpos(i1,month,year)*3*(font->w)), y+(2+ypos(i1,month,year))*(font->h), TMPSTRING, hcolor);
		else
			gdImageString(image, font, x+(xpos(i1,month,year)*3*(font->w)), y+(2+ypos(i1,month,year))*(font->h), TMPSTRING, tcolor);
		}
	}
			
}

/* Height of the Year-Cal */
int ycalheight(gdFontPtr font, int month, int year, int layout) {
	int i1,i2,i3,ret;

	ret=0;
	i3=0;
	if(layout == 'v') {
		for(i1=0; i1<month; i1+=2) {
			i2=(3+ypos(ME(i1+1,year),i1+1,year))*(font->h);
			i3=(3+ypos(ME(i1+2,year),i1+2,year))*(font->h);
			ret+=max(i2,i3);
		}
		ret+=((month/2)-1)*VERS;
	}
	else {
		for(i1=1; i1<=min(6,month); i1++) {
			i2=(3+ypos(ME(i1,year),i1,year))*(font->h);
			ret=max(i2,ret);
		}
		if(month > 6) {
			for(i1=1; i1<=month; i1++) {
				i2=(3+ypos(ME(i1,year),i1,year))*(font->h);
				i3=max(i2,i3);
			}
		ret+=i3;
		ret+=VERS;
		}
	}

	return(ret);
}

/* Create Year-Calendar at x,y */
void YearGraphCal(gdImagePtr image, gdFontPtr font, int day, int month, int year, int x, int y, int tcolor, int hcolor, int acolor, int sbgcolor, int dcolor, int layout) {
	int i1;
	int vers=0;
	int me;
	int d;
	
	if(layout == 'v') {
		for(i1=0; i1<12; i1+=2) {
			if((i1+1)==month)
				d=day;
			else
				d=0;
			SmallGraphCal(image, font, d, i1+1, year, x, y + ycalheight(font, i1, year, layout)+VERS, tcolor, hcolor, acolor, sbgcolor, dcolor);
			if((i1+2)==month)
				d=day;
			else
				d=0;
			SmallGraphCal(image, font, d, i1+2, year, x + VERS + (20*font->w) ,y + ycalheight(font, i1, year, layout)+VERS , tcolor, hcolor, acolor, sbgcolor, dcolor);

			
		}	
	}
	else {
		for(i1=0; i1<6; i1++) {
			if((i1+1)==month)
				d=day;
			else
				d=0;
			SmallGraphCal(image, font, d, i1+1, year, x + i1*(VERS + (20*font->w)) , y, tcolor, hcolor, acolor, sbgcolor, dcolor);
			if((i1+7)==month)
				d=day;
			else
				d=0;
			SmallGraphCal(image, font, d, i1+7, year, x + i1*(VERS + (20*font->w)) , y + ycalheight(font, 6, year, layout) + VERS, tcolor, hcolor, acolor, sbgcolor, dcolor);

		}
	}
}

/* Calender background standalone */
void calbg(int argc, char *argv[]) {
	int i1=0,i2=0,i3=0;
	int height,width;
	gdImagePtr image;
	int asJPG;
	FILE *file;
	FILE *bgfile;
	FILE *ConvStream;
	int bgcolor;
	int tcolor;
	int hcolor;
	int acolor;
	int dcolor;
	int sbgcolor;
	char BGCOLOR[MAXCOLOR+1];
	char TCOLOR[MAXCOLOR+1];
	char HCOLOR[MAXCOLOR+1];
	char ACOLOR[MAXCOLOR+1];
	char DCOLOR[MAXCOLOR+1];
	char SBGCOLOR[MAXCOLOR+1];
	int jpegqu;
	int option_index;
	int day;
	int month;
	int year;
	int wantyear;
	int ylayout;
	time_t Zeit;
	struct tm ZP;
	char TMPLINE[MAXSTRING+1];
	char OUTFILE[MAXSTRING+1];
	char *z1;
	int position, posx, posy;
	int yposition,yposx,yposy;
	int two;
	gdFontPtr font=gdFontLarge;
	gdFontPtr font_tiny=gdFontTiny;
	gdFontPtr font_year=gdFontSmall;
	gdImagePtr bgimage;
	int imagetype;
	float factor;
	int nomonth;
	char *imagefilename;
	int removeimage;
	
	static struct option long_options[] =
	{
		/* name, no_argument/required_argument/optional_argument, NULL/var, val */
		{"file", required_argument, 0, 'f' },
		{"filename", required_argument, 0, 'f' },
		{"help", no_argument, 0, 'h'},
		{"height", required_argument, 0, 'H'},
		{"width", required_argument, 0, 'W'},
		{"png", no_argument, 0, 'p'},
		{"jpg", optional_argument, 0, 'j'},
		{"bmp", no_argument, 0, 'b'},
		{"bgcolor", required_argument, 0, 0},
		{"tcolor", required_argument, 0, 0},
		{"hcolor", required_argument, 0, 0},
		{"acolor", required_argument, 0, 0},
		{"dcolor", required_argument, 0, 0},
		{"sbgcolor", required_argument, 0, 0},
		{"position", required_argument, 0, 0},
		{"posx", required_argument, 0, 0},
		{"posy", required_argument, 0, 0},
		{"yposition", required_argument, 0, 0},
		{"yposx", required_argument, 0, 0},
		{"yposy", required_argument, 0, 0},
		{"ylayout", optional_argument, 0, 0},
		{"two", optional_argument, 0, 0},
		{"today", optional_argument, 0, 0},
		{"month", required_argument, 0, 'm'},
		{"year", required_argument, 0, 'y'},
		{"image", required_argument, 0, 0},
		{"tiled", no_argument, 0, 0},
		{"stretched", no_argument, 0, 0},
		{"centered", no_argument, 0, 0},
		{"fit", no_argument, 0, 0},
		{"nomonth", no_argument, 0, 0},
		{"removeimage", no_argument, 0, 0},
		{0,0,0,0}
	};

	char short_options[]="hH:W:f:jpbm:y:";

	imagefilename=NULL;
	option_index = 0;
	height=0;
	width=0;
	image=NULL;
	asJPG=JPG_DEFAULT;
	file=stdout;
	bgcolor=-1;
	tcolor=-1;
	hcolor=-1;
	acolor=-1;
	dcolor=-1;
	sbgcolor=-1;
	strncpy(BGCOLOR,DEF_BGCOLOR,MAXCOLOR);
	strncpy(TCOLOR,DEF_TCOLOR,MAXCOLOR);
	strncpy(HCOLOR,DEF_HCOLOR,MAXCOLOR);
	strncpy(ACOLOR,DEF_ACOLOR,MAXCOLOR);
	strncpy(DCOLOR,DEF_DCOLOR,MAXCOLOR);
	strncpy(SBGCOLOR,DEF_SBGCOLOR,MAXCOLOR);
	jpegqu=JPEG_QUALITY;
	day=-1;
	month=-1;
	year=-1;
	position=DEF_POSITION;
	posx=-1;
	posy=-1;
	yposition=DEF_YPOSITION;
	yposx=-1;
	yposy=-1;
	wantyear=0;
	ylayout=DEF_YLAYOUT;
	two=DEF_TWO;
	imagetype='n';
	bgimage=NULL;
	bgfile=NULL;
	OUTFILE[0]=(char)NULL;
	nomonth=0;
	removeimage=0;

	i1=getopt_long(argc, argv, short_options, long_options, &option_index);
	while(i1 != -1) {
		switch(i1) {
			case 0:
				if(strcmp(long_options[option_index].name,"bgcolor") == 0) { /* Background Color */
					if(optarg == NULL)
						break;
					strncpy(BGCOLOR,optarg,MAXCOLOR);
				}

				if(strcmp(long_options[option_index].name,"tcolor") == 0) { /* Text Color */
					if(optarg == NULL)
						break;
					strncpy(TCOLOR,optarg,MAXCOLOR);
				}

				if(strcmp(long_options[option_index].name,"hcolor") == 0) { /* Holiday Color */
					if(optarg == NULL)
						break;
					strncpy(HCOLOR,optarg,MAXCOLOR);
				}

				if(strcmp(long_options[option_index].name,"acolor") == 0) { /* Assumption day Color */
					if(optarg == NULL)
						break;
					strncpy(ACOLOR,optarg,MAXCOLOR);
				}

				if(strcmp(long_options[option_index].name,"dcolor") == 0) { /* Marked today Color */
					if(optarg == NULL)
						break;
					strncpy(DCOLOR,optarg,MAXCOLOR);
				}


				if(strcmp(long_options[option_index].name,"sbgcolor") == 0) { /* Background Color of cal */
					if(optarg == NULL)
						break;
					strncpy(SBGCOLOR,optarg,MAXCOLOR);
				}

				if(strcmp(long_options[option_index].name,"position") == 0) { /* Predefined Postion of small cal */
					if(optarg == NULL)
						break;
					position=atoi(optarg);
				}

				if(strcmp(long_options[option_index].name,"posx") == 0) { /* X-Position of small cal */
					if(optarg == NULL)
						break;
					posx=atoi(optarg);
				}

				if(strcmp(long_options[option_index].name,"posy") == 0) { /* Y-Position of small cal */
					if(optarg == NULL)
						break;
					posy=atoi(optarg);
				}
				if(strcmp(long_options[option_index].name,"ylayout") == 0) { /* Want year cal */
					wantyear=1;
					if(optarg == NULL) {
						break;
					}
					if(optarg[0] == 'v')
						ylayout='v';
					else
						ylayout='h';
				}
				
				if(strcmp(long_options[option_index].name,"yposition") == 0) { /* Predefined Postion of year cal */
					if(optarg == NULL)
						break;
					yposition=atoi(optarg);
					wantyear=1;
				}

				if(strcmp(long_options[option_index].name,"yposx") == 0) { /* X-Position of year cal */
					if(optarg == NULL)
						break;
					yposx=atoi(optarg);
					wantyear=1;
				}

				if(strcmp(long_options[option_index].name,"yposy") == 0) { /* Y-Position of year cal */
					if(optarg == NULL)
						break;
					yposy=atoi(optarg);
					wantyear=1;
				}

				if(strcmp(long_options[option_index].name,"two") == 0) { /* Two small cal's */
					two='v';
					if(optarg != NULL) {
						if(optarg[0] == 'h')
							two='h';
					}
						
				}
				
				if(strcmp(long_options[option_index].name,"image") == 0) { /* Nice Background-Image */
					if(optarg != NULL) {
						imagefilename=(char *)malloc((size_t)(strlen(optarg)+2));
						if(imagefilename != NULL) {
							strncpy(imagefilename,optarg,(size_t)(strlen(optarg)+1));				
							bgfile=fopen(imagefilename,"r");
							if(bgfile != NULL) {
								bgimage=gdImageCreateFromPng(bgfile);
								if(bgimage == NULL) {
									rewind(bgfile);
									bgimage=gdImageCreateFromJpeg(bgfile);
								}
								fclose(bgfile);
							}
						}
					}
				}

				if(strcmp(long_options[option_index].name,"tiled") == 0) { /* The image is a tiled image */
					imagetype='t';
				}

				if(strcmp(long_options[option_index].name,"stretched") == 0) { /* The image should be stretched */
					imagetype='s';
				}

				if(strcmp(long_options[option_index].name,"centered") == 0) { /* The image should be centered */
					imagetype='c';
				}

				if(strcmp(long_options[option_index].name,"fit") == 0) { /* The image should fit */
					imagetype='f';
				}
				
				if(strcmp(long_options[option_index].name,"today") == 0) { /* Mark today */
					if(optarg != NULL)
						day=atoi(optarg);	
					else
						day=0;
				}

				if(strcmp(long_options[option_index].name,"nomonth") == 0) { /* Only Year-Cal */
					nomonth=1;
				}	

				if(strcmp(long_options[option_index].name,"removeimage") == 0) { /* Remove Backgroundimage */
					removeimage=1;
				}	
				
			break;

			case 'h': /* HELP */
				printf("Usage: %s %s\n\n",argv[0],HELP_CALBG);
				return;
			break;
			case 'W': /* WIDTH */
				width=atoi(optarg);
			break;
			case 'H': /* HEIGHT */
				height=atoi(optarg);
			break;
			case 'p': /* asPNG */
				asJPG=0;
			break;
			case 'j': /* asJPG */
				asJPG=1;
				if(optarg != NULL)
					jpegqu=atoi(optarg);
			break;
			case 'b': /* asBMP */
				asJPG=2;
			break;
			case 'f': /* OutPutFile */
				strncpy(OUTFILE,optarg,MAXSTRING);
			break;
			case 'm': /* Month */
				if(optarg != NULL)
					month=atoi(optarg);	
			break;
			case 'y': /*Year */
				if(optarg != NULL)
					year=atoi(optarg);
			break;
			case '?': /* Error */
				printf("Illegal function call.... ;-)\n");
				exit;
			break;
			default:  /* Unknown return value */
				printf ("?? getopt returned character code 0%o ??\n", i1);
			break;
		}
		i1=getopt_long(argc, argv, short_options, long_options, &option_index);
	}		

	if((width==0) && (height==0)) {
		width=DEF_WIDTH;
		height=DEF_HEIGHT;
	}
	if(width==0)
		width=height*4/3;
	if(height==0)
		height=width*3/4;
		
	if((month == -1) | (year == -1) | (day == 0)) {
		Zeit=time((time_t *)NULL);
		ZP=*localtime(&Zeit);
		if(month == -1)
			month=ZP.tm_mon+1;
		if(year == -1)
			year=ZP.tm_year+1900;
		if(day == 0)
			day=ZP.tm_mday;
	}

	image=gdImageCreate(width,height);

	bgcolor=getColor(image,BGCOLOR);
	tcolor=getColor(image,TCOLOR);
	hcolor=getColor(image,HCOLOR);
	acolor=getColor(image,ACOLOR);
	dcolor=getColor(image,DCOLOR);
	sbgcolor=getColor(image,SBGCOLOR);

	/* Background Images */
	if(bgimage != NULL) {
		switch(imagetype) {
			case 's':	/* stretched */
				gdImageCopyResized(image,bgimage, 0, 0, 0, 0, image->sx, image->sy, bgimage->sx, bgimage->sy);
			break;
			case 't':	/* tiled */
				gdImageSetTile(image,bgimage);
				gdImageFill(image,0,0,gdTiled);
			break;
			case 'c':	/* centered */
			case 'f':	/* fit */
				factor=fmin((float)image->sx / (float)bgimage->sx, (float)image->sy / (float)bgimage->sy);
				if((imagetype=='c') && (factor > 1.0))
					factor=1.0;
				gdImageCopyResized(image,bgimage,(int)(image->sx-factor*(bgimage->sx))/2,(int)(image->sy-factor*(bgimage->sy))/2, 0, 0, (int)(factor*(bgimage->sx)), (int)(factor*(bgimage->sy)), bgimage->sx, bgimage->sy);
			break;
			default:
				gdImageCopy(image, bgimage, 0, 0, 0, 0, bgimage->sx, bgimage->sy);
			break;
		}
	}

	/* Draw the Calendar */

	if((posx == -1) || (posy == -1)) {
		i1=ME(month,year);
		i2=20*(font->w);
		i3=(3+ypos(i1,month,year))*(font->h);

		if(two == 'v') {
			
			if(month < 12) {
				i1=ME(month+1,year);
				i3+=(3+ypos(i1,month,year))*(font->h)+VERS;
			}
			else {
				i1=ME(1,year+1);
				i3+=(3+ypos(i1,month,year))*(font->h)+VERS;
			}
		}
		
		if(two == 'h')
	   		i2=i2*2+VERS;	
		
		switch(position) {
			case 1:
				posx=VERS;
				posy=height-i3-VERS;
			break;
			case 2:
				posx=(width-i2)/2;
				posy=height-i3-VERS;
			break;
			case 3:
				posx=width-i2-VERS-1;
				posy=height-i3-VERS;	
			break;
			case 4:
				posx=VERS;
				posy=(height-i3)/2;
			break;
			case 5:
				posx=(width-i2)/2;
				posy=(height-i3)/2;
			break;
			case 6:
				posx=width-i2-VERS-1;
				posy=(height-i3)/2;
			break;
			case 7:
				posx=VERS;
				posy=VERS;
			break;
			case 8:
				posx=(width-i2)/2;
				posy=VERS;
			break;
			case 9:
				posx=width-i2-VERS-1;
				posy=VERS;
			break;
			default:
				posx=VERS;
				posy=VERS;
			break;
		}
	}

	if((two != 0) && (!nomonth)) {
		i1=ME(month,year);
		i2=20*(font->w);
		i3=(3+ypos(i1,month,year))*(font->h);

		if(two == 'h') {
			i2=0;
			i3=20*(font->w)+VERS;
		}
		else {
			i2=(3+ypos(i1,month,year))*(font->h)+VERS;
			i3=0;
		}
			
		if(month < 12)
			SmallGraphCal(image,font,0, month+1,year,posx+i3,posy+i2,tcolor,hcolor,acolor,sbgcolor, dcolor);
		else
			SmallGraphCal(image,font,0, 1,year+1,posx+i3,posy+i2,tcolor,hcolor,acolor,sbgcolor, dcolor);
		

	}

	if(!nomonth)
		SmallGraphCal(image,font,day, month,year,posx,posy,tcolor,hcolor,acolor,sbgcolor, dcolor);

	if(wantyear == 1) {
		if((yposx == -1) || (yposy == -1)) {
			i1=20*font_year->w;
			if(ylayout == 'v') {
				i1*=2;
				i1+=VERS;
			}
			else {
				i1*=6;
				i1+=5*VERS;
			}
			i2=ycalheight(font_year,12,year,ylayout);

			switch(yposition) {
				case 1:
					yposx=VERS;
					yposy=height-i2-VERS;
				break;
				case 2:
					yposx=(width-i1)/2;
					yposy=height-i2-VERS;
				break;
				case 3:
					yposx=width-i1-1-VERS;
					yposy=height-i2-VERS;
				break;
				case 4:
					yposx=VERS;
					yposy=(height-i2)/2;
				break;
				case 5:
					yposx=(width-i1)/2;
					yposy=(height-i2)/2;
				break;
				case 6:
					yposx=width-i1-VERS-1;
					yposy=(height-i2)/2;
				break;
				case 7:
					yposx=VERS;
					yposy=VERS;
				break;
				case 8:
					yposx=(width-i1)/2;
					yposy=VERS;
				break;
				case 9:
					yposx=width-i1-VERS-1;
					yposy=VERS;
				break;
				default:
					yposx=VERS;
					yposy=VERS;
				break;
			}
		}
			YearGraphCal(image,font_year,day,month,year,yposx,yposy,tcolor,hcolor,acolor,sbgcolor,dcolor,ylayout);
	}

	/* ----------------- */

	if((asJPG != 2) && (OUTFILE[0] != (char)NULL)) {
		file=fopen(OUTFILE,"w");
		if(file == NULL) {
			printf("Error opening %s\n",OUTFILE);
			exit;
		}
	}

	if(asJPG == 1)
		gdImageJpeg(image,file,jpegqu);
	if(asJPG == 0)
		gdImagePng(image,file);
	
	if(asJPG == 2) {
		if(OUTFILE[0] == (char)NULL)
			strcpy(OUTFILE,"-");
		snprintf(TMPLINE,(size_t)MAXSTRING,"%s%s",CONVERT,OUTFILE);

		ConvStream=popen(TMPLINE,"w");
		if(ConvStream != (FILE *)NULL) {
			gdImagePng(image,ConvStream);

			fflush(stdout);
			pclose(ConvStream);
		}
	}
			
	
	if(bgimage != NULL) {
		gdImageDestroy(bgimage);
		if(imagefilename != NULL) {
			if(removeimage == 1) 
				unlink(imagefilename);
			free(imagefilename);
		}	
	}	
	if(file != (FILE *)NULL)
		fclose(file);
	gdImageDestroy(image);
}

void cgi(int argc, char *argv[]) {
	char QUERY[MAXSTRING+1];
	char arguments[ANZARGS+1][MAXSTRING+1];
	char *argptr[ANZARGS+1];
	int argcount, i1, i2, height, width, uheight, uwidth, usersize;
	char *z1,*z2,*z3,*z4;
	unsigned char merk;
	int imagetype,jpgqu;
	int onlyimagedata;
	int debug;
	int pos,posx,posy;
	int ypos,yposx,yposy;
	FILE *ifile;
	void *memptr;
	long l1;

	debug=0;
	
	QUERY[0]=(char)NULL;

	if(getenv("CONTENT_LENGTH") == NULL) {

		printf("Content-type: text/html\n\n");

		printf("<HTML><HEAD><TITLE>%s</TITLE></HEAD><BODY>\n",PROGNAME);
		printf("<H1>%s</H1>\n",PROGNAME_LONG);
		printf("<FORM ACTION=\"%s\" METHOD=post enctype=\"multipart/form-data\">",argv[0]);
		printf("<HR>\n");
		printf("<H3>%s</H3>\n",TEXT_SIZE);
		printf("<INPUT TYPE=\"radio\" NAME=\"SIZE\" VALUE=\"640x480\"> 640x480</INPUT><BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"SIZE\" VALUE=\"800x600\" CHECKED> 800x600</INPUT><BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"SIZE\" VALUE=\"1024x768\"> 1024x768</INPUT><BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"SIZE\" VALUE=\"1152x870\"> 1152x870</INPUT><BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"SIZE\" VALUE=\"1280x1024\"> 1280x1024</INPUT><BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"SIZE\" VALUE=\"1600x1200\"> 1600x1200</INPUT><BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"SIZE\" VALUE=\"USER\">");
			printf(" <INPUT TYPE=\"text\" NAME=SIZEX SIZE=5 MAXLENGTH=5>");		
			printf(" X <INPUT TYPE=\"text\" NAME=SIZEY SIZE=5 MAXLENGTH=5>");
		printf("</INPUT><BR>\n");

		printf("<HR>\n");
		printf("<H3>%s</H3>\n",TEXT_IMAGETYPE);
		printf("<INPUT TYPE=\"radio\" NAME=\"IMAGETYPE\" VALUE=\"PNG\" CHECKED> PNG</INPUT><BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"IMAGETYPE\" VALUE=\"JPG\"> JPG</INPUT> (%s: <INPUT TYPE=\"text\" NAME=JPGQU VALUE=%i SIZE=3 MAXLENGTH=3>)<BR>\n",TEXT_QUALITY,JPEG_QUALITY);
		printf("<INPUT TYPE=\"radio\" NAME=\"IMAGETYPE\" VALUE=\"BMP\"> BMP</INPUT><BR>\n");

		printf("<HR>\n");
		printf("<H3>%s</H3>\n",TEXT_COLORS);	
		printf("<TABLE BORDER=0>\n");
		printf("<TR><TD>%s</TD><TD><INPUT TYPE=\"text\" NAME=BGCOLOR SIZE=7 MAXLENGTH=7></TD></TR>",TEXT_BGCOLOR);
		printf("<TR><TD>%s</TD><TD><INPUT TYPE=\"text\" NAME=SBGCOLOR SIZE=7 MAXLENGTH=7></TD></TR>",TEXT_SBGCOLOR);
		printf("<TR><TD>%s</TD><TD><INPUT TYPE=\"text\" NAME=TCOLOR SIZE=7 MAXLENGTH=7></TD></TR>",TEXT_TCOLOR);
		printf("<TR><TD>%s</TD><TD><INPUT TYPE=\"text\" NAME=HCOLOR SIZE=7 MAXLENGTH=7></TD></TR>",TEXT_HCOLOR);
		printf("<TR><TD>%s</TD><TD><INPUT TYPE=\"text\" NAME=ACOLOR SIZE=7 MAXLENGTH=7></TD></TR>",TEXT_ACOLOR);
		printf("<TR><TD>%s</TD><TD><INPUT TYPE=\"text\" NAME=DCOLOR SIZE=7 MAXLENGTH=7></TD></TR>",TEXT_DCOLOR);
		printf("</TABLE>\n");

		printf("<HR>\n");
		printf("<H3>%s</H3>\n",TEXT_CAL);
		printf("<INPUT TYPE=\"radio\" NAME=\"POS\" VALUE=\"100\"> %s</INPUT>\n",TEXT_DISABLE);
		printf("<BR><br>\n");
		printf("<b>%s</b><br>\n",TEXT_POSITION);
		printf("<INPUT TYPE=\"radio\" NAME=\"POS\" VALUE=\"7\">&nbsp;</INPUT>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"POS\" VALUE=\"8\">&nbsp;</INPUT>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"POS\" VALUE=\"9\">&nbsp;</INPUT>\n");
		printf("<BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"POS\" VALUE=\"4\">&nbsp;</INPUT>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"POS\" VALUE=\"5\">&nbsp;</INPUT>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"POS\" VALUE=\"6\">&nbsp;</INPUT>\n");
		printf("<BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"POS\" VALUE=\"1\">&nbsp;</INPUT>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"POS\" VALUE=\"2\">&nbsp;</INPUT>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"POS\" VALUE=\"3\" CHECKED>&nbsp;</INPUT>\n");
		printf("<BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"POS\" VALUE=\"0\"> %s ",TEXT_FREEPOSITION); 
			printf(" <INPUT TYPE=\"text\" NAME=POSX SIZE=5 MAXLENGTH=5>");
			printf(" X <INPUT TYPE=\"text\" NAME=POSY SIZE=5 MAXLENGTH=5>");
		printf("</INPUT>\n");
		printf("<BR>\n");
		printf("<b>%s</b><br>\n",TEXT_TWOCAL);
		printf("<INPUT TYPE=\"radio\" NAME=\"TWOCAL\" VALUE=\"n\" CHECKED> %s</INPUT>\n",TEXT_DISABLE);
		printf("&nbsp;&nbsp;&nbsp;<INPUT TYPE=\"radio\" NAME=\"TWOCAL\" VALUE=\"h\"> %s</INPUT>\n",TEXT_HORZ);
		printf("&nbsp;&nbsp;&nbsp;<INPUT TYPE=\"radio\" NAME=\"TWOCAL\" VALUE=\"v\"> %s</INPUT>\n",TEXT_VERT);

		printf("<HR>\n");
		printf("<H3>%s</H3>\n",TEXT_YEARCAL);
		printf("<INPUT TYPE=\"radio\" NAME=\"YPOS\" VALUE=\"100\" CHECKED> %s</INPUT>\n",TEXT_DISABLE);
		printf("<BR><br>\n");
		printf("<b>%s</b><br>\n",TEXT_POSITION);
		printf("<INPUT TYPE=\"radio\" NAME=\"YPOS\" VALUE=\"7\">&nbsp;</INPUT>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"YPOS\" VALUE=\"8\">&nbsp;</INPUT>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"YPOS\" VALUE=\"9\">&nbsp;</INPUT>\n");
		printf("<BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"YPOS\" VALUE=\"4\">&nbsp;</INPUT>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"YPOS\" VALUE=\"5\">&nbsp;</INPUT>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"YPOS\" VALUE=\"6\">&nbsp;</INPUT>\n");
		printf("<BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"YPOS\" VALUE=\"1\">&nbsp;</INPUT>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"YPOS\" VALUE=\"2\">&nbsp;</INPUT>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"YPOS\" VALUE=\"3\">&nbsp;</INPUT>\n");
		printf("<BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"YPOS\" VALUE=\"0\"> %s ",TEXT_FREEPOSITION);
			printf(" <INPUT TYPE=\"text\" NAME=YPOSX SIZE=5 MAXLENGTH=5>");
			printf(" X <INPUT TYPE=\"text\" NAME=YPOSY SIZE=5 MAXLENGTH=5>");
		printf("</INPUT>\n");
		printf("<BR>\n");
		printf("<INPUT TYPE=\"radio\" NAME=\"YLAYOUT\" VALUE=\"h\"> %s</INPUT>\n",TEXT_HORZ);
		printf("&nbsp;&nbsp;&nbsp;<INPUT TYPE=\"radio\" NAME=\"YLAYOUT\" VALUE=\"v\"> %s</INPUT>\n",TEXT_VERT);
		printf("<HR>\n");
		printf("<H3>%s</H3>\n",TEXT_DATE);
		printf("<table border=0>\n");
		printf("<tr>\n");	
		printf("<td>%s</td><td><INPUT TYPE=\"text\" NAME=DAY SIZE=2 MAXLENGTH=2></td><td><INPUT TYPE=\"checkbox\" NAME=\"MARKTODAY\" VALUE=\"1\">%s</INPUT></td>",TEXT_DAY,TEXT_MARKTODAY);
		printf("</tr><tr>\n");
		printf("<td>%s</td><td><INPUT TYPE=\"text\" NAME=MONTH SIZE=2 MAXLENGTH=2></td>",TEXT_MONTH);
		printf("</tr><tr>\n");
		printf("<td>%s</td><td><INPUT TYPE=\"text\" NAME=YEAR SIZE=4 MAXLENGTH=4></td>",TEXT_YEAR);
		printf("</tr></table>\n");
		printf("<HR>\n");
		/*printf("<INPUT TYPE=\"checkbox\" NAME=\"DEBUG\" VALUE=\"1\"> Debug</INPUT>\n");
		printf("<HR>\n"); */
		printf("<H3>%s</H3>\n",TEXT_BACKGROUNDIMAGE);
		printf("<INPUT TYPE=\"radio\" NAME=\"IMAGESCAL\" VALUE=\"d\" CHECKED>%s</INPUT>\n",TEXT_IMAGESCAL_DEFAULT);
		printf("<INPUT TYPE=\"radio\" NAME=\"IMAGESCAL\" VALUE=\"t\">%s</INPUT>\n",TEXT_IMAGESCAL_TILED);
		printf("<INPUT TYPE=\"radio\" NAME=\"IMAGESCAL\" VALUE=\"f\">%s</INPUT>\n",TEXT_IMAGESCAL_FIT);
		printf("<INPUT TYPE=\"radio\" NAME=\"IMAGESCAL\" VALUE=\"c\">%s</INPUT>\n",TEXT_IMAGESCAL_CENTER);
		printf("<INPUT TYPE=\"radio\" NAME=\"IMAGESCAL\" VALUE=\"s\">%s</INPUT>\n",TEXT_IMAGESCAL_STRETCH);
		printf("<BR>\n");
		printf("<input name=\"IMAGE\" type=\"file\" size=\"50\" maxlength=\"1000000\" accept=\"image/*\">\n");
		printf("<INPUT TYPE=\"hidden\" NAME=\"DEVNULL\" VALUE=\"EMPTY\">\n");
		printf("<HR>\n");
		printf("<input type=\"submit\" value=\" %s \"> <input type=\"reset\" value=\" %s \">\n", BUTTON_OK,BUTTON_RESET);
		printf("</FORM>\n");

		
		/* printf("bla"); */

		
		printf("</BODY></HTML>\n");
	}
	else {
		l1=atol(getenv("CONTENT_LENGTH"));
		memptr=malloc((size_t)(l1+1));
		if(memptr == NULL) {
			printf("Content-type: text/html\n\nUnable to allocate memory !\n");
			exit;
		}

		z1=memptr;
        i1=fgetc(stdin);
		i1=0;
		//printf("Content-type: text/html\n\n");	/* DEBUG */
        while((i1 != EOF) && (l1 > 0L)) {
			*z1=(char)i1;		
			z1++;
	       	i1=fgetc(stdin); 
			//putchar(i1);	/* DEBUG */
		   	l1--;
		}	
		*z1 = (char)NULL;

		height=0;
		width=0;
		uheight=0;
		uwidth=0;
		usersize=0;	
		pos=-1;
		posx=-1;
		posy=-1;
		ypos=-1;
		yposx=-1;
		yposy=-1;
		imagetype=JPG_DEFAULT;
		jpgqu=JPEG_QUALITY;
		strncpy(QUERY,getenv("QUERY_STRING"),(size_t)MAXSTRING);	
		strncpy(arguments[0],argv[0],(size_t)MAXSTRING);
		argcount=1;
		onlyimagedata=0;

		z1=memptr;
		z1++;

		z2=strstr(z1,"\"DEBUG\"");
		if(z2 != NULL) {
			z2+=10;
			if(*z2 == 13) {
				debug=0;	
			}
			else {
				printf("Content-type: text/html\n\n");
				printf("DEBUG<br>\n");
				debug=1;
			}
		}	

		z2=strstr(z1,"\"SIZE\"");
		if(z2 != NULL) {
			z2+=9;
			z3=z2;
			while(*z2 != 13)
				z2++;	
			*z2=(char)NULL;

			if(strcmp(z3,"USER") == 0) {
				usersize=1;
			}
			else {
				z4=strchr(z3,'x');
				if(z4 != NULL) {
					*z4=(char)NULL;
					width=atoi(z3);
					height=atoi(z4+1);
					*z4='x';
				}
			}
			*z2=13;
		}

		z2=strstr(z1,"\"OID\"");
		if(z2 != NULL) {
			z2+=8;
			if((*z2 == 13) || (*z2 == '0')) {
				onlyimagedata=0;
			}
			else {	
				onlyimagedata=1;
			}	
		}	

		z2=strstr(z1,"\"SIZEX\"");
		if(z2 != NULL) {
			z2+=10;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			uwidth=atoi(z3);
			*z2=13;	
		}	

		z2=strstr(z1,"\"SIZEY\"");
		if(z2 != NULL) {
			z2+=10;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			uheight=atoi(z3);
			*z2=13;
		}	

		z2=strstr(z1,"\"IMAGETYPE\"");
		if(z2 != NULL) {
			z2+=15;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(strcmp(z3,"PNG") == 0) {
				imagetype=0;
			}
			if(strcmp(z3,"JPG") == 0) {
				imagetype=1;
			}
			if(strcmp(z3,"BMP") == 0) {
				imagetype=2;
			}	
			*z2=13;
		}	

		z2=strstr(z1,"\"JPGQU\"");
		if(z2 != NULL) {
			z2+=10;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			jpgqu=atoi(z3);	
			*z2=13;
		}	

		z2=strstr(z1,"\"BGCOLOR\"");
		if(z2 != NULL) {
			z2+=13;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(*z3 != (char)NULL) {
				if((*z3 == '%') && (strlen(z3) > 3))
					z3+=3;
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--bgcolor=%s",z3);
				argcount++;
				if(argcount > ANZARGS)
					exit;	
			}
			
			*z2=13;
		}	
			
		z2=strstr(z1,"\"TCOLOR\"");
		if(z2 != NULL) {
			z2+=12;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(*z3 != (char)NULL) {
				if((*z3 == '%') && (strlen(z3) > 3))
					z3+=3;
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--tcolor=%s",z3);
				argcount++;
				if(argcount > ANZARGS)
					exit;	
			}
			
			*z2=13;
		}	

		z2=strstr(z1,"\"HCOLOR\"");
		if(z2 != NULL) {
			z2+=12;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(*z3 != (char)NULL) {
				if((*z3 == '%') && (strlen(z3) > 3))
					z3+=3;
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--hcolor=%s",z3);
				argcount++;
				if(argcount > ANZARGS)
					exit;	
			}
			
			*z2=13;
		}	

		z2=strstr(z1,"\"ACOLOR\"");
		if(z2 != NULL) {
			z2+=12;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(*z3 != (char)NULL) {
				if((*z3 == '%') && (strlen(z3) > 3))
					z3+=3;
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--acolor=%s",z3);
				argcount++;
				if(argcount > ANZARGS)
					exit;	
			}
			
			*z2=13;
		}	

		z2=strstr(z1,"\"DCOLOR\"");
		if(z2 != NULL) {
			z2+=12;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(*z3 != (char)NULL) {
				if((*z3 == '%') && (strlen(z3) > 3))
					z3+=3;
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--dcolor=%s",z3);
				argcount++;
				if(argcount > ANZARGS)
					exit;	
			}
			
			*z2=13;
		}	

		z2=strstr(z1,"\"SBGCOLOR\"");
		if(z2 != NULL) {
			z2+=14;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(*z3 != (char)NULL) {
				if((*z3 == '%') && (strlen(z3) > 3))
					z3+=3;
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--sbgcolor=%s",z3);
				argcount++;
				if(argcount > ANZARGS)
					exit;	
			}
			
			*z2=13;
		}	

		z2=strstr(z1,"\"DAY\"");
		if(z2 != NULL) {
			z4=strstr(z1,"\"MARKTODAY\"");
			if(z4 != NULL) {
				z4+=14;
				if(*z4 != 13) {		
					z2+=9;
					z3=z2;
					while(*z2 != 13)
						z2++;
					*z2=(char)NULL;
					if(*z3 != (char)NULL) 
						snprintf(arguments[argcount],(size_t)MAXSTRING,"--today=%i",atoi(z3));
					else
						snprintf(arguments[argcount],(size_t)MAXSTRING,"--today");	
					argcount++;
					if(argcount > ANZARGS)
						exit;
				}	
			}
			*z2=13;
		}

		z2=strstr(z1,"\"MONTH\"");
		if(z2 != NULL) {
			z2+=11;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(*z3 != (char)NULL) {
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--month=%i",atoi(z3));
				argcount++;
				if(argcount > ANZARGS)
					exit;
			}
			*z2=13;
		}		

		z2=strstr(z1,"\"YEAR\"");
		if(z2 != NULL) {
			z2+=10;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(*z3 != (char)NULL) {
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--year=%i",atoi(z3));
				argcount++;
				if(argcount > ANZARGS)
					exit;
			}
			*z2=13;
		}		

		
		z2=strstr(z1,"\"POS\"");
		if(z2 != NULL) {
			z2+=9;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(z3 != NULL) 
				pos=atoi(z3);
			*z2=13;
		}	

		z2=strstr(z1,"\"POSX\"");
		if(z2 != NULL) {
			z2+=10;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(z3 != NULL) 
				posx=atoi(z3);
			*z2=13;
		}	

		z2=strstr(z1,"\"POSY\"");
		if(z2 != NULL) {
			z2+=10;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(z3 != NULL) 
				posy=atoi(z3);
			*z2=13;
		}	

		z2=strstr(z1,"\"YPOS\"");
		if(z2 != NULL) {
			z2+=10;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(z3 != NULL) 
				ypos=atoi(z3);
			*z2=13;
		}	

		z2=strstr(z1,"\"YPOSX\"");
		if(z2 != NULL) {
			z2+=11;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(z3 != NULL) 
				yposx=atoi(z3);
			*z2=13;
		}	

		z2=strstr(z1,"\"YPOSY\"");
		if(z2 != NULL) {
			z2+=11;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(z3 != NULL) 
				yposy=atoi(z3);
			*z2=13;
		}	


		z2=strstr(z1,"\"YLAYOUT\"");
		if(z2 != NULL) {
			z2+=13;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(z3 != NULL) {
				if(*z3 == 'h') {
					snprintf(arguments[argcount],(size_t)MAXSTRING,"--ylayout=h");
					argcount++;
					if(argcount > ANZARGS)
						exit;
				}	
				if(*z3 == 'v') {
					snprintf(arguments[argcount],(size_t)MAXSTRING,"--ylayout=v");	
					argcount++;
					if(argcount > ANZARGS)
						exit;
				}
			}	
			*z2=13;
		}	

		z2=strstr(z1,"\"TWOCAL\"");
		if(z2 != NULL) {
			z2+=12;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(z3 != NULL) {
				if(*z3 == 'h') {
					snprintf(arguments[argcount],(size_t)MAXSTRING,"--two=h");
					argcount++;
					if(argcount > ANZARGS)
						exit;
				}
				if(*z3 == 'v') {
					snprintf(arguments[argcount],(size_t)MAXSTRING,"--two=v");
					argcount++;
					if(argcount > ANZARGS)
						exit;
				}
			}
			*z2=13;
		}	

		z2=strstr(z1,"\"IMAGE\"");
		if(z2 != NULL) {
			z2=strstr(z2,"filename");
			if(z2 != NULL) {
				z2+=10;
				z3=z2;
				while(*z2 != '\"')
				z2++;
				*z2=(char)NULL;
				if(*z3 == (char)NULL) {
					*z2='\"';
				}
				else {		
					snprintf(TMPFILE,(size_t)MAXSTRING,"%s%u_%s",TMPPREFIX,(unsigned)getpid(),z3);
					*z2='\"';
					z2++;
					while((*z2 != 13) && (*z2 != EOF))
						z2++;
					z2++;
					while((*z2 != 13) && (*z2 != EOF))
						z2++;
					z2++;
					while((*z2 != 13) && (*z2 != EOF))
						z2++;
					z2+=2;
					i1=0;
					ifile=fopen(TMPFILE,"w");
					if(ifile == NULL) {
						printf("Content-type: text/html\n\nError opening temporary file !\n");
						exit(-1);
					}			
					do {
						fputc((int)*z2,ifile);
						z2++;
						if((*z2 == 13) && (*(z2+1) == 10) && (*(z2+2) == '-') && (*(z2+3) == '-') && (*(z2+4) == '-'))
							i1=1;
					}
					while(i1==0);
					fclose(ifile);

					snprintf(arguments[argcount],(size_t)MAXSTRING,"--image=%s",TMPFILE);
					argcount++;
					if(argcount > ANZARGS)
						exit(-1);

					snprintf(arguments[argcount],(size_t)MAXSTRING,"--removeimage");
					argcount++;
					if(argcount > ANZARGS)
						exit(-1);	
				}	
			}	
		}	

		z2=strstr(z1,"\"IMAGESCAL\""); 
		if(z2 != NULL) {
			z2+=15;
			z3=z2;
			while(*z2 != 13)
				z2++;
			*z2=(char)NULL;
			if(z3 != NULL) {
				if(*z3 == 't') {
					snprintf(arguments[argcount],(size_t)MAXSTRING,"--tiled");
					argcount++;
					if(argcount > ANZARGS)
						exit;
				}
				if(*z3 == 's') {
					snprintf(arguments[argcount],(size_t)MAXSTRING,"--stretched");	
					argcount++;
					if(argcount > ANZARGS)
						exit;
				}
				if(*z3 == 'c') {		
					snprintf(arguments[argcount],(size_t)MAXSTRING,"--centered");	
					argcount++;
					if(argcount > ANZARGS)
						exit;
				}
				if(*z3 == 'f') {	
					snprintf(arguments[argcount],(size_t)MAXSTRING,"--fit");	
					argcount++;
					if(argcount > ANZARGS)
						exit;
				}	
			}
			*z2=13;
		}


		free(memptr);

		if((usersize == 0) && (width > 0)) {
			snprintf(arguments[argcount],(size_t)MAXSTRING,"--width=%i",width);
			argcount++; 
			if(argcount > ANZARGS)
				exit;
		}

		if((usersize == 0) && (height > 0)) {
			snprintf(arguments[argcount],(size_t)MAXSTRING,"--height=%i",height);
			argcount++; 
			if(argcount > ANZARGS)
				exit;
		}

		if((usersize == 1) && (uwidth > 0)) {
			snprintf(arguments[argcount],(size_t)MAXSTRING,"--width=%i",uwidth);
			argcount++;
			if(argcount > ANZARGS)
				exit;
		}

		if((usersize == 1) && (uheight > 0)) {
			snprintf(arguments[argcount],(size_t)MAXSTRING,"--height=%i",uheight);
			argcount++;
			if(argcount > ANZARGS)
				exit;
		}

		if((pos > 0) && (ypos < 10)) {
			snprintf(arguments[argcount],(size_t)MAXSTRING,"--pos=%i",pos);	
			argcount++;
			if(argcount > ANZARGS)
				exit;
		}
		
		if(pos == 0) {
			if((posx > 0) && (posy > 0)) {	
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--posx=%i",posx);
				argcount++;
				if(argcount > ANZARGS)
					exit;	
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--posy=%i",posy);
				argcount++;
				if(argcount > ANZARGS)
					exit;
			}
		}		

		if(pos == 100) {
			snprintf(arguments[argcount],(size_t)MAXSTRING,"--nomonth");
			argcount++;
			if(argcount > ANZARGS)
				exit;
		}	

		if((ypos > 0) && (ypos < 10)) {
			snprintf(arguments[argcount],(size_t)MAXSTRING,"--ypos=%i",ypos);
			argcount++;
			if(argcount > ANZARGS)
				exit;
		}

		if(ypos == 0) {
			if((yposx > 0) && (yposy > 0)) {
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--yposx=%i",yposx);
				argcount++;
				if(argcount > ANZARGS)
					exit;
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--yposy=%i",yposy);
				argcount++;
				if(argcount > ANZARGS)
					exit;
			}
		}
		
		switch(imagetype) {
			case 0:
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--png");
				argcount++;
				if(argcount > ANZARGS)
					exit;	
				printf("Content-type: image/png\n\n");
			break;
			case 1:
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--jpg=%i",jpgqu);	
				argcount++;
				if(argcount > ANZARGS)
					exit;	
				printf("Content-type: image/jpeg\n\n");
			break;
			case 2:
				snprintf(arguments[argcount],(size_t)MAXSTRING,"--bmp");	
				argcount++;
				if(argcount > ANZARGS)
					exit;	
				printf("Content-type: image/bmp\n\n");
			break;	
			default:
				exit;
			break;	
		}		

		for(i1=0; i1<argcount; i1++) {
			if(debug)
				printf("-->%s<br>\n",arguments[i1]);
			argptr[i1]=arguments[i1];	
		}
		if(!debug)
			calbg(argcount,argptr);
	}


	
}

int caltxt(int argc, char *argv[]) {
	int day,month,year;

	day=0;
	month=0;
	year=0;
		
	printf("Optionen: Ab wann, wieviele Tage\n");

		
	

}	

int main(int argc, char *argv[]) {

	if(strcmp((char *)basename(argv[0]),"test") == 0) {
		if(argc != 4) 
			printf("Usage: %s <DD> <MM> <YYYY>\n\n",argv[0]);
		else
			test(atoi(argv[1]),atoi(argv[2]),atoi(argv[3]));
		return(0);
	}

	if(strcmp((char *)basename(argv[0]),"calbg") == 0) {
		calbg(argc,argv);
	}

	if(strcmp((char *)basename(argv[0]),"calbg.cgi") == 0) {
		cgi(argc,argv);
	}
	if(strcmp((char *)basename(argv[0]),"calbg.cgi") == 0) {
		printf("Not yet implemented !\n");
	}
	if(strcmp((char *)basename(argv[0]),"caltxt") == 0) {
		caltxt(argc,argv);
	}
		
	return(0);
}
